--This script will run on all levels when mod is active.
--Modding documentation: http://teardowngame.com/modding
--API reference: http://teardowngame.com/modding/api.html

function rnd(mi, ma)
    return math.random(1000)/1000*(ma-mi) + mi
end


function partsInit()

	if GetString('savegame.mod.dog_companion.version') ~= '0.2' then
		SetString('savegame.mod.dog_companion.version', '0.2')
		SetInt('savegame.mod.dog_companion.head',1)
		SetInt('savegame.mod.dog_companion.body',1)
			
		SetInt('savegame.mod.dog_companion.leg_front_right',1)
		SetInt('savegame.mod.dog_companion.foot_front_right',1)
			
		SetInt('savegame.mod.dog_companion.leg_front_left',1)
		SetInt('savegame.mod.dog_companion.foot_front_left',1)
			
		SetInt('savegame.mod.dog_companion.leg_back_left',1)
		SetInt('savegame.mod.dog_companion.foot_back_left',1)
			
		SetInt('savegame.mod.dog_companion.leg_back_right',1)
		SetInt('savegame.mod.dog_companion.foot_back_right',1)
		SetInt('savegame.mod.dog_companion.earl',1)
		SetInt('savegame.mod.dog_companion.earr',1)
		
		SetInt('savegame.mod.dog_companion.tail1',1) --Tail root
		SetInt('savegame.mod.dog_companion.tail2',1)
		SetInt('savegame.mod.dog_companion.tail3',1) --Tail Tip
	end 
	
	parts = {}
	
	parts.files= {"fren.vox","jeffrey.vox","bone.vox","larry.vox"}
	
	parts.head = GetInt('savegame.mod.dog_companion.head')
	parts.body = GetInt('savegame.mod.dog_companion.body')
	
	parts.leg_front_right = GetInt('savegame.mod.dog_companion.leg_front_right')
	parts.foot_front_right = GetInt('savegame.mod.dog_companion.foot_front_right')
	
	parts.leg_front_left = GetInt('savegame.mod.dog_companion.leg_front_left')
	parts.foot_front_left = GetInt('savegame.mod.dog_companion.foot_front_left')
	
	parts.leg_back_left = GetInt('savegame.mod.dog_companion.leg_back_left')
	parts.foot_back_left = GetInt('savegame.mod.dog_companion.foot_back_left')
	
	parts.leg_back_right = GetInt('savegame.mod.dog_companion.leg_back_right')
	parts.foot_back_right = GetInt('savegame.mod.dog_companion.foot_back_right')
	
	
	parts.tail1 = GetInt('savegame.mod.dog_companion.tail1')
	parts.tail2 = GetInt('savegame.mod.dog_companion.tail2')
	parts.tail3 = GetInt('savegame.mod.dog_companion.tail3')
	
	
	parts.earl = {"earl"}
	parts.earl = GetInt('savegame.mod.dog_companion.earl')
	parts.earr = GetInt('savegame.mod.dog_companion.earr')
end

function spawn(t)
    XML = [[
			<prefab version="1.0.0">
			<group name="instance=MOD/spawn/Dog.xml" pos="0.0 3.3 0.0" rot="0.0 0.0 0.0">
				<script pos="-0.0 0.0 -0.8" rot="0.0 0.0 0.0" file="MOD/robot.lua" param0="type=chase">
					<group pos="-0.1 0.0 0.0" rot="0.0 0.0 0.0">
						<body name="head" tags="head" pos="0.1 0.9 -0.3" dynamic="true">
							<vox pos="0.0 0.0 0.1" rot="0.0 180.0 0.0" object="head"  																file="MOD/dogs/]]..parts.files[parts.head]..[[" >
								<light tags="eye" pos="0.05 0.35 0.05" type="area" color="1 0.8 0.6" scale="0" size="0.5 0.1" fogscale="0" sound=" "/>
							</vox>
							<joint tags="head" pos="-0.05 0.2 0.3" rot="-90.0 90.0 0.0" type="hinge" limits="-70 70"/>
						</body>
						<body name="earl grey" tags="ear" pos="0.2 1.6 -0.05" dynamic="true">
							<vox pos="0.0 -0.2 0.05" object="earl" 																					file="MOD/dogs/]]..parts.files[parts.earl]..[[" >
								<joint pos="0.0 0.0 -0.05" rot="180.0 -90.0 -10.0" type="hinge" rotstrength="0.01" rotspring="0.05"/>
							</vox>
						</body>
						<body name="earr" tags="ear" pos="-0.1 1.6 -0.05" dynamic="true">
							<vox pos="0.0 -0.2 0.05"  object="earr" 																				file="MOD/dogs/]]..parts.files[parts.earr]..[[">
								<joint pos="0.0 0.0 -0.05" rot="0.0 90.0 0.0" type="hinge" rotstrength="0.01" rotspring="0.05"/>
							</vox>
						</body>
						<body name="body" tags="body" pos="0.1 0.5 0.788" dynamic="true">
							<vox pos="0.0 0.0 -0.08833" rot="0.0 -180.0 0.0" object="body"															file="MOD/dogs/]]..parts.files[parts.body]..[["/>
						</body>
						<body name="roottail" pos="0.1 0.96 1.602" rot="0.0 0.0 0.0" dynamic="true">
							<vox pos="0.0 -0.0442 -0.00561" rot="10.0 -180.0 0.0" collide="true"  object="tailSegment" 								file="MOD/dogs/]]..parts.files[parts.tail1]..[[" />
							<joint pos="-0.04891 -0.012 -0.1114" rot="-180.0 -90.0 80.0" rotspring="0" collide="true"/>
						</body>
						<body name="midtail" pos="0.1 1.011 1.896" rot="0.0 0.0 0.0" dynamic="true">
							<vox pos="0.0 -0.0442 -0.00561" rot="10.0 -180.0 0.0" collide="true"  object="tailSegment"								file="MOD/dogs/]]..parts.files[parts.tail2]..[["/>
							<joint pos="-0.04891 -0.012 -0.1114" rot="-180.0 -90.0 80.0" rotspring="0" collide="true"/>
						</body>
						<body name="tail tip" tags="tail" pos="0.1 1.092 2.37" rot="-20.0 0.0 0.0" dynamic="true">
							<vox name="tailtip" pos="0.0 -0.007 -0.196" rot="-10.0 -180.0 0.0" density="3" collide="true" object="tailSegment"		file="MOD/dogs/]]..parts.files[parts.tail3]..[[" />
							<joint pos="-0.05186 0.051 -0.289" rot="-50.0 0.0 0.0" rotspring="0" collide="true"/>
						</body>
						<body name="back right leg" tags="leg" pos="0.3 0.4 1.3" dynamic="true">
						<vox name="right back leg" pos="0.0 0.0 0.0" rot="0.0 -180.0 0.0"  object="leg_back"									file="MOD/dogs/]]..parts.files[parts.leg_back_right]..[[">
							<joint pos="0.1 0.45 -0.05" rot="0.0 -90.0 0.0" type="hinge" rotstrength="0" rotspring="0" collide="true"/>
						</vox>
						</body>
						<body name="back right foot" tags="foot" pos="0.3 0.0 1.3" dynamic="true">
							<vox pos="0.0 0.0 0.0" rot="0.0 -180.0 0.0" density="0.2"  object="foot_back"											file="MOD/dogs/]]..parts.files[parts.foot_back_right]..[[" >
								<joint pos="0.05 0.4 -0.05" rot="0.0 90.0 0.0" type="hinge" rotstrength="1" rotspring="0" collide="false" limits="-90 90"/>
							</vox>
						</body>
						<body name="front left leg" tags="leg" pos="-0.2 0.3 0.2" dynamic="true">
							<vox pos="0.1 0.0 0.0" rot="0.0 -180.0 0.0"  object="leg_front" 														file="MOD/dogs/]]..parts.files[parts.leg_front_left]..[[" >
								<joint pos="0.0 0.45 -0.05" rot="0.0 90.0 0.0" type="hinge" rotstrength="0" rotspring="0" collide="true"/>
							</vox>
						</body>
						<body name="front left foot" tags="foot" pos="-0.2 0.0 0.2" dynamic="true">
							<vox pos="0.1 0.0 0.0" rot="0.0 -180.0 0.0" density="0.2"  object="foot_front"											file="MOD/dogs/]]..parts.files[parts.foot_front_left]..[[" >
								<joint pos="0.05 0.3 -0.05" rot="180.0 -90.0 0.0" type="hinge" rotspring="0" collide="false" limits="-90 90"/>
							</vox>
						</body>
						<body name="front right leg" tags="leg" pos="0.2 0.3 0.2" dynamic="true">
							<vox pos="0.1 0.0 0.0" rot="0.0 -180.0 0.0" object="leg_front" 															file="MOD/dogs/]]..parts.files[parts.leg_front_right]..[[">
								<joint pos="0.1 0.45 -0.05" rot="0.0 -90.0 0.0" type="hinge" rotstrength="0" rotspring="0" collide="true"/>
							</vox>
						</body>
						<body name="front right foot" tags="foot" pos="0.2 0.0 0.2" dynamic="true">
							<vox pos="0.1 0.0 0.0" rot="0.0 -180.0 0.0" density="0.2"  object="foot_front"											file="MOD/dogs/]]..parts.files[parts.foot_front_right]..[[">
								<joint pos="0.05 0.3 -0.05" rot="180.0 -90.0 0.0" type="hinge" rotstrength="1" rotspring="0" collide="false" limits="-90 90"/>
							</vox>
						</body>
						<body name="back left foot" tags="foot" pos="-0.1 0.0 1.3" dynamic="true">
							<vox pos="0.0 0.0 0.0" rot="0.0 -180.0 0.0" density="0.2"  object="foot_back"											file="MOD/dogs/]]..parts.files[parts.foot_back_left]..[[">
								<joint pos="0.05 0.4 -0.05" rot="0.0 90.0 0.0" type="hinge" rotstrength="1" rotspring="0" limits="-90 90"/>
							</vox>
						</body>

						<body name="back left leg" tags="leg" pos="-0.1 0.4 1.3" dynamic="true">
							<vox pos="0.0 0.0 0.0" rot="0.0 -180.0 0.0"  object="leg_back"															file="MOD/dogs/]]..parts.files[parts.leg_back_left]..[[">
								<joint pos="0.0 0.45 -0.05" rot="0.0 90.0 0.0" type="hinge" rotstrength="0" rotspring="0" collide="true"/>
							</vox>
						</body>
					</group>
				</script>
			</group>
		</prefab>
    ]]

    Spawn(XML,t)
end

function init()
	if GetString('savegame.mod.dog_companion.killed') == "dead" then 
		return
	end 
	partsInit()

	count = 0
	once = false
	while(true) do
		count = count + 1
		local t = VecAdd(GetPlayerTransform().pos, Vec(math.random(-5,5), 2, math.random(-5,5)))
		QueryRequire("physical large static")
		local hit, d = QueryRaycast(t, Vec(0, -1, 0), 25)
		hitpos = VecAdd(t, VecScale(Vec(0, -1, 0), d))
		--if distance to player and hitpos is more than 3 dont spawn
		if not IsPointInWater(hitpos) and 3 > VecLength(VecSub(hitpos, GetPlayerTransform().pos)) then
			if hit then
				spawn(Transform(hitpos))
				break
			end
		end
		if count > 100 then
			break
		end
	end

	RegisterTool("Bone", "Bone", "MOD/prop/bone.vox",1)
    SetBool("game.tool.Bone.enabled", true)
end





function clamp(value, mi, ma)
	if value < mi then value = mi end
	if value > ma then value = ma end
	return value
end



function tick(dt)

	if InputDown("p") and InputDown("l") and InputDown("s") then 
		SetString('savegame.mod.dog_companion.killed',"")
	end

	if GetString('savegame.mod.dog_companion.killed') == "dead" then 
		return
	end 

	bone = FindBody("bone",true)

	if bone == 0 then
		SetBool("game.tool.Bone.enabled", true)
		once = false
	else
		if once == false then 
			SetBool("game.tool.Bone.enabled", false)
			SetString("game.player.tool","")
			once = true
		end
	end


	if GetString("game.player.tool") == "Bone" then
		ToolTransform = Transform()
		ToolTransform.pos = Vec(0.775,-0.625, -0.875)
		ToolTransform.rot = QuatEuler(90,90,0)
		SetToolTransform(ToolTransform,1.2)

		local LocalTr = Transform(Vec(-0,0.05,-0.875))
		local PointOnTool = TransformToParentPoint(GetBodyTransform(GetToolBody()),LocalTr.pos)
		local ToolOrigin = TransformToParentPoint(GetBodyTransform(GetToolBody()),Vec(0,0,0))
		local t = GetCameraTransform()
		local dir = TransformToParentVec(t, {0, 0, -1})
        local velocity = VecScale(dir, 15) 
        if bone == 0 and InputDown("usetool") then
            local vox = Spawn("MOD/spawn/bone.xml", Transform(PointOnTool))
            SetBodyVelocity(vox[1], VecAdd(Vec(math.random(),math.random(),math.random()),velocity))
			bone = FindBody("bone",true)
			SetBodyAngularVelocity(bone,Vec(math.random(-10,10),math.random(-10,10),math.random(-10,10)))
        end
    end
	if GetPlayerInteractBody() == bone and InputDown('interact') or IsPointInWater(GetBodyTransform(bone).pos) and bone ~= 0 then 
		Delete(bone)
		SetString("game.player.tool","Bone")
	end
end


function update(dt)
end


function draw(dt)
end


