function partsInit()

if GetString('savegame.mod.dog_companion.version') ~= '0.2' then
    SetString('savegame.mod.dog_companion.version', '0.2')
    SetInt('savegame.mod.dog_companion.head',1)
    SetInt('savegame.mod.dog_companion.body',1)
        
    SetInt('savegame.mod.dog_companion.leg_front_right',1)
    SetInt('savegame.mod.dog_companion.foot_front_right',1)
        
    SetInt('savegame.mod.dog_companion.leg_front_left',1)
    SetInt('savegame.mod.dog_companion.foot_front_left',1)
        
    SetInt('savegame.mod.dog_companion.leg_back_left',1)
    SetInt('savegame.mod.dog_companion.foot_back_left',1)
        
    SetInt('savegame.mod.dog_companion.leg_back_right',1)
    SetInt('savegame.mod.dog_companion.foot_back_right',1)
    SetInt('savegame.mod.dog_companion.earl',1)
    SetInt('savegame.mod.dog_companion.earr',1)
    
    SetInt('savegame.mod.dog_companion.tail1',1) --Tail root
    SetInt('savegame.mod.dog_companion.tail2',1)
    SetInt('savegame.mod.dog_companion.tail3',1) --Tail Tip
end 

parts = {}

parts.files= {"fren.vox","jeffrey.vox","bone.vox","larry.vox"}

parts.head = GetInt('savegame.mod.dog_companion.head')
parts.body = GetInt('savegame.mod.dog_companion.body')

parts.leg_front_right = GetInt('savegame.mod.dog_companion.leg_front_right')
parts.foot_front_right = GetInt('savegame.mod.dog_companion.foot_front_right')

parts.leg_front_left = GetInt('savegame.mod.dog_companion.leg_front_left')
parts.foot_front_left = GetInt('savegame.mod.dog_companion.foot_front_left')

parts.leg_back_left = GetInt('savegame.mod.dog_companion.leg_back_left')
parts.foot_back_left = GetInt('savegame.mod.dog_companion.foot_back_left')

parts.leg_back_right = GetInt('savegame.mod.dog_companion.leg_back_right')
parts.foot_back_right = GetInt('savegame.mod.dog_companion.foot_back_right')


parts.tail1 = GetInt('savegame.mod.dog_companion.tail1')
parts.tail2 = GetInt('savegame.mod.dog_companion.tail2')
parts.tail3 = GetInt('savegame.mod.dog_companion.tail3')


parts.earl = {"earl"}
parts.earl = GetInt('savegame.mod.dog_companion.earl')
parts.earr = GetInt('savegame.mod.dog_companion.earr')



end

function init()

    partsInit()

    outline = 0
    camLoc = FindLocation("cam",true)
    camLoc = GetLocationTransform(camLoc)
    spawnLoc = GetLocationTransform(FindLocation("spawn",true))
    spawn()
end

function tick()
    SetBodyActive(FindBody("dog",true),false)
    SetPlayerTransform(camLoc,true)
end

function del()
    local shapes = FindShapes("dog",true)
    for i,v in ipairs(shapes) do
        Delete(v)
    end
    Delete(FindBody("dog",true))
end

function spawn()
    if GetString('savegame.mod.dog_companion.killed') == "dead" then 
		return
	end 
    XML = [[
        <group name="instance=MOD/spawn/switch.xml" pos="0.0 0.0 0.0" rot="0.0 -30 0.0">
            <body tags="dog nocull" pos="0 0 0" dynamic="false">

                <vox pos="0.0 0.5 0.0" collide="false" prop="false"                                object="body"                file="MOD/dogs/]]..parts.files[parts.body]..[["                         tags="dog=body"/>

                <vox pos="0.0 0.9 -0.956" rot="21.2 0.0 0.0" collide="false" prop="false"          object="tailSegment"         file="MOD/dogs/]]..parts.files[parts.tail1]..[["                                        tags="dog=tail1"/>
                <vox pos="0.0 1.027 -1.2" rot="43.5 0.0 0.0" collide="false" prop="false"          object="tailSegment"         file="MOD/dogs/]]..parts.files[parts.tail2]..[["                                       tags="dog=tail2"/>
                <vox pos="0.0 1.255 -1.358" rot="78.5 0.0 0.0" collide="false" prop="false"        object="tailSegment"         file="MOD/dogs/]]..parts.files[parts.tail3]..[["                                        tags="dog=tail3"/>


                <vox pos="-0.074 0.9 0.981" rot="0.0 -17.8 0.0" collide="false" prop="false"       object="head"                file="MOD/dogs/]]..parts.files[parts.head]..[["                         tags="dog=head"/>

                <vox pos="0.147 1.4 0.947" rot="0.0 -17.8 0.0" collide="false" prop="false"        object="earl"                file="MOD/dogs/]]..parts.files[parts.earl]..[["                         tags="dog=earl"/>
                <vox pos="-0.139 1.4 0.855" rot="0.0 -17.8 0.0" collide="false" prop="false"       object="earr"                file="MOD/dogs/]]..parts.files[parts.earr]..[["                         tags="dog=earr"/>


                <vox pos="-0.2 0.3 0.445" rot="6.3 0.0 0.0" collide="false" prop="false"           object="leg_front"           file="MOD/dogs/]]..parts.files[parts.leg_front_right]..[["              tags="dog=leg_front_right"/>
                <vox pos="-0.2 0.0 0.45" collide="false" prop="false"                              object="foot_front"          file="MOD/dogs/]]..parts.files[parts.foot_front_right]..[["             tags="dog=foot_front_right"/>

                <vox pos="0.2 0.3 0.445" rot="6.3 0.0 0.0" collide="false" prop="false"            object="leg_front"           file="MOD/dogs/]]..parts.files[parts.leg_front_left]..[["               tags="dog=leg_front_left"/>
                <vox pos="0.2 0.0 0.45" collide="false" prop="false"                               object="foot_front"          file="MOD/dogs/]]..parts.files[parts.foot_front_left]..[["              tags="dog=foot_front_left"/>

                <vox pos="0.2 0.4 -0.6" rot="9.2 0.0 0.0" collide="false" prop="false"             object="leg_back"            file="MOD/dogs/]]..parts.files[parts.leg_back_left]..[["                tags="dog=leg_back_left"/>
                <vox pos="0.2 0.0 -0.6" collide="false" prop="false"  file="MOD/dogs/fren.vox"     object="foot_back"          file="MOD/dogs/]]..parts.files[parts.foot_back_left]..[["               tags="dog=foot_back_left"/>

                <vox pos="-0.2 0.4 -0.6" rot="9.2 0.0 0.0" collide="false" prop="false"            object="leg_back"            file="MOD/dogs/]]..parts.files[parts.leg_back_right]..[["               tags="dog=leg_back_right"/>
                <vox pos="-0.2 0.0 -0.6" collide="false" prop="false"                              object="foot_back"           file="MOD/dogs/]]..parts.files[parts.foot_back_right]..[["              tags="dog=foot_back_right"/>

            </body>
	    </group>
    ]]

    Spawn(XML,Transform(spawnLoc.pos))
end




function draw()
    UiMakeInteractive()
    local x, y = UiGetMousePos()
    local dir = UiPixelToWorld(x, y)
    local pos = GetCameraTransform().pos
    local hit, dist,_,shape = QueryRaycast(pos, dir, 100)
    SetCameraDof(dist,10)
    SetCameraFov(18)
    if hit and HasTag(shape,"dog") and InputPressed("lmb") then
        local tagVal = GetTagValue(shape,"dog")
        if GetInt('savegame.mod.dog_companion.'..tagVal) < #parts.files then 
            SetInt('savegame.mod.dog_companion.'..tagVal,tonumber(GetInt('savegame.mod.dog_companion.'..tagVal))+1)
            del()
            partsInit()
            spawn()
        else
            SetInt('savegame.mod.dog_companion.'..tagVal,1)
            del()
            partsInit()
            spawn()
        end
    end
    DogInfo()
end


function DogInfo()
	UiPush()
	UiTranslate(UiCenter(), UiHeight() - 100)
	UiAlign("center bottom")
	UiColor(1 ,1 ,1 , 1)
	UiImageBox("MOD/images/sign-02.png", 480, 140, 75, 75)
	UiFont("bold.ttf", 45)
	UiPush()    
	UiColor(1,1,1,1)
	UiTranslate(0,-70)
	UiText(string.upper("Dog customization!"))
    
	UiColor(1 ,1 ,1 , 1)
	UiFont("regular.ttf", 24)

	UiTranslate(-200,10)
	UiAlign("left top")
	UiWordWrap(400)
	UiText("Click on the dog to change the appearence!")
    UiPop()

    UiPush()
    UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)




	UiColor(1 ,1 ,1 , 1)
	UiFont("regular.ttf", 24)
	UiTranslate(0, 50)
	if UiTextButton("Close", 80, 40) then
		Menu()
	end
    UiPop()
end